package RSSReader::Gtk2UI::GeneralProperties;
use strict;
use RSSReader::Configuration;
#use RSSReader::GtkUI::Notifiers;
use RSSReader::GtkUI::Preferences;
use base qw(RSSReader::Logger);

sub run {
  my $c    = shift;

  my $conf  = RSSReader::Configuration->new();
  my $prefs = RSSReader::GtkUI::Preferences->new(); 

  my $w    = new Gnome2::App('_properties', "General preferences");
  my $vbox = new Gtk2::VBox; 
  $w->set_contents($vbox);
  $w->set_default_size( 600, 400 );
  $w->set_modal(1);

  my $notebook = new Gtk2::Notebook();
  $vbox->pack_start($notebook,1,1,1);
  $notebook->set_tab_pos('top');

  my $s = bless { }, $c;

  #PAGE 1;
  my $vbox_page1 = new Gtk2::VBox; 
  my $page1_label = new Gtk2::Label('General');
  $notebook->append_page( $vbox_page1, $page1_label);

    # ZEEE TABLE

    my $table_page1 = new Gtk2::Table(5,5,0);

    $s->{_fetch_int_l} = new Gtk2::Label('Default fetch interval (Mins) :');
    $s->{_fetch_int_l}->set_alignment(0.0,1.0);
    my $adj = new Gtk2::Adjustment( 1.0, 0.0, 36000, 1.0, 10.0, undef );
    $s->{_fetch_int_s} = new Gtk2::SpinButton( $adj, '0.5', 0 );
    $s->{_fetch_int_s}->set_value($prefs->fetch_interval);
    $s->{_fetch_int_s}->signal_connect('changed', sub {$s->_activate_apply});

    $s->{_auto_save_l} = new Gtk2::Label('Data auto save :');
    $s->{_auto_save_l}->set_alignment(1.0,1.0);
    $s->{_auto_save_e} = new Gtk2::CheckButton(' enable');

    $s->{_auto_save_int_l} = new Gtk2::Label('Auto save interval (Mins):');
    $s->{_auto_save_int_l}->set_alignment(1.0,1.0);
    my $adj2 = new Gtk2::Adjustment( 1.0, 0.0, 36000, 1.0, 10.0, undef );
    $s->{_auto_save_int_s} = new Gtk2::SpinButton( $adj2, '0.5', 0 );
    $s->{_auto_save_int_s}->set_value($prefs->auto_save_interval);
    $s->{_auto_save_int_s}->show();
    $s->{_auto_save_int_s}->set_sensitive(0);
    $s->{_auto_save_int_s}->signal_connect('changed', sub {$s->_activate_apply});

    $s->{_save_on_exit_l} = new Gtk2::Label('Save data on exit :');
    $s->{_save_on_exit_l}->set_alignment(1.0,1.0);
    $s->{_save_on_exit_e} = new Gtk2::CheckButton(' enable');
    if ($prefs->save_on_exit) { $s->{_save_on_exit_e}->set_active(1); }
    $s->{_save_on_exit_e}->signal_connect_after('toggled',sub {$s->_activate_apply});

    if ( $prefs->auto_save() ) { 
    		$s->{_auto_save_e}->set_active(1); 
		$s->{_auto_save_int_s}->set_sensitive(1);  
    }

    $table_page1->attach($s->{_fetch_int_l}      ,0,1,0,1,['fill','shrink'], 		[], 4,4);
    $table_page1->attach($s->{_fetch_int_s}      ,1,2,0,1,['fill','shrink','expand'], 	[], 4,4);
    $table_page1->attach($s->{_auto_save_l}      ,0,1,1,2,['fill','shrink'], 		[], 4,4); 
    $table_page1->attach($s->{_auto_save_e}      ,1,2,1,2,['fill','shrink'], 		[], 4,4);
    $table_page1->attach($s->{_auto_save_int_l}  ,0,1,2,3,['fill','shrink'], 		[], 4,4); 
    $table_page1->attach($s->{_auto_save_int_s}  ,1,2,2,3,['fill','shrink'], 		[], 4,4); 
    $table_page1->attach($s->{_save_on_exit_l}   ,0,1,3,4,['fill','shrink'],            [], 4,4);
    $table_page1->attach($s->{_save_on_exit_e}   ,1,2,3,4,['fill','shrink'],            [], 4,4);

    $table_page1->show_all();


  $vbox_page1->pack_start($table_page1, 1,1,1);

  #PAGE 2;
  my $vbox_page2= new Gtk2::VBox;
  my $page2_label = new Gtk2::Label('Messages');
  #$notebook->append_page( $vbox_page2, $page2_label );


  #PAGE 3;
  my $pane_page3= new Gtk2::HPaned;
  $pane_page3->set_position(200);
  my $page3_label = new Gtk2::Label('Notifications');
  my $table_page3_1 = new Gtk2::Table(2,1,0);
#  $notebook->append_page( $pane_page3, $page3_label );
     my $list_label =  new Gtk2::Label('Available Notifiers');
  
#     my $list_scrolled_win = new Gtk2::ScrolledWindow( undef, undef );
#     $list_scrolled_win->set_policy( 'automatic', 'automatic' );
#     my $list = new Gtk::CList(1);
#     $list->set_column_auto_resize(0,1);
#     $list_scrolled_win->add( $list );
#     $list_scrolled_win->show_all();
     

     #FIXME
     #my @notifiers = RSSReader::GtkUI::Notifiers->get_notifiers();
     #foreach (@notifiers) {
     #	my $row = $list->append($_->name());
     #	$list->set_row_data($row, { _id => $_->id() } );
     #}
     #$list->signal_connect_after('select_row',         sub { $_[1]->_notifier_selected(row=> $_[2], column=> $_[3]) },$s);

#     $table_page3_1->attach($list_label  ,0,1,0,1,['fill','shrink','expand'], [], 2,4);
#     $table_page3_1->attach($list_scrolled_win  ,0,1,1,2,['fill','shrink','expand'], ['expand', 'fill'], 2,4);
     $table_page3_1->show_all;
     $s->{_notifier_pane_table} = $table_page3_1; 
#     $s->{_notifier_pane_list}  = $list;
     $s->{_notifier_pane}       = $pane_page3;
 
  $pane_page3->add1($table_page3_1);

  #PAGE 4;
  my $vbox_page4 = new Gtk2::VBox; 
  my $page4_label = new Gtk2::Label('GUI');
  $notebook->append_page( $vbox_page4, $page4_label);
    #ZEE TABLE
    my $table_page4 = new Gtk2::Table(5,5,0);

    $s->{_same_column_width_l} = new Gtk2::Label('Use same column width for every view:');
    $s->{_same_column_width_l}->set_alignment(0.0,1.0);
    $s->{_same_column_width_e} = new Gtk2::CheckButton();
    $s->{_same_column_width_e}->set_active(1) unless $prefs->option('per_view_columns');
    $s->{_same_column_width_e}->signal_connect_after('toggled',sub {$s->_activate_apply});
	
    $s->{_same_pane_size_l} = new Gtk2::Label('Use same pane size for every view:');
    $s->{_same_pane_size_l}->set_alignment(0.0,1.0);
    $s->{_same_pane_size_e} = new Gtk2::CheckButton();
    $s->{_same_pane_size_e}->set_active(1) unless $prefs->option('per_view_pane');
    $s->{_same_pane_size_e}->signal_connect_after('toggled',sub {$s->_activate_apply});

    $table_page4->attach($s->{_same_column_width_l}      ,0,1,0,1,['fill','shrink'], 		[], 4,4);
    $table_page4->attach($s->{_same_column_width_e}      ,1,2,0,1,['fill','shrink'], 		[], 4,4);
    $table_page4->attach($s->{_same_pane_size_l}         ,0,1,1,2,['fill','shrink'], 		[], 4,4);
    $table_page4->attach($s->{_same_pane_size_e}         ,1,2,1,2,['fill','shrink'], 		[], 4,4);

    $table_page4->show_all();


  $vbox_page4->pack_start($table_page4, 1,1,1);

  #PAGE 5
  my $vbox_page5  = new Gtk2::VBox;
  my $page5_label = new Gtk2::Label('Proxy');
  $notebook->append_page($vbox_page5, $page5_label); 
 
     #Zee desc label.
     my $page5_t_label = "When enabled, this option causes all connections to pass trough the specified proxy address.";
     my $page5_label = new Gtk2::Label($page5_t_label);
     $vbox_page5->pack_start($page5_label, 0,1,10);


     $s->{_page_5_proxy_enable_a} = new Gtk2::Alignment(0.5,0.5,0,0);
     $s->{_page_5_proxy_enable} = new Gtk2::CheckButton(' Enable proxy support');
     $s->{_page_5_proxy_enable_a}->add($s->{_page_5_proxy_enable});
     $vbox_page5->pack_start($s->{_page_5_proxy_enable_a}, 0,1,10);
     $s->{_page_5_proxy_enable}->set_active(1) if $prefs->option('http_proxy_enabled');

     #ZEE table
     my $table_page5 = new Gtk2::Table(5,5,0);
     my $table_page5_a = new Gtk2::Alignment(0.5,0.5,0,0);
     $table_page5_a->add($table_page5);
     $s->{_page_5_proxy_host_l} = new Gtk2::Label('Proxy address: ');
     $s->{_page_5_proxy_host_l}->set_alignment(0.0,1.0);
     $s->{_page_5_proxy_host_e} = new Gtk2::Entry();
     $s->{_page_5_proxy_host_e}->set_sensitive(0) unless $prefs->option('http_proxy_enabled');
     $s->{_page_5_proxy_host_e}->set_text($prefs->option('http_proxy_host'));
     $s->{_page_5_proxy_host_e}->signal_connect("changed", sub { $s->_activate_apply } );

     $s->{_page_5_proxy_port_l} = new Gtk2::Label('Proxy port: ');
     $s->{_page_5_proxy_port_l}->set_alignment(0.0,1.0);
     $s->{_page_5_proxy_port_e} = new Gtk2::Entry();
     $s->{_page_5_proxy_port_e}->set_sensitive(0) unless $prefs->option('http_proxy_enabled');
     $s->{_page_5_proxy_port_e}->set_text($prefs->option('http_proxy_port'));
     $s->{_page_5_proxy_port_e}->signal_connect("changed", sub { $s->_activate_apply } );

     $table_page5->attach($s->{_page_5_proxy_host_l}      ,0,1,0,1,['shrink'], 		[], 4,4);
     $table_page5->attach($s->{_page_5_proxy_host_e}      ,1,2,0,1,['shrink'], 		[], 4,4);
     $table_page5->attach($s->{_page_5_proxy_port_l}      ,0,1,1,2,['shrink'], 		[], 4,4);
     $table_page5->attach($s->{_page_5_proxy_port_e}      ,1,2,1,2,['shrink'], 		[], 4,4);
     $vbox_page5->pack_start($table_page5_a, 0,1,20);

     $s->{_page_5_proxy_enable}->signal_connect_after('toggled',sub { $s->_activate_apply;
								      if ($s->{_page_5_proxy_enable}->get_active) {
									$s->{_page_5_proxy_host_e}->set_sensitive(1);
									$s->{_page_5_proxy_port_e}->set_sensitive(1);
								      } else {
									$s->{_page_5_proxy_port_e}->set_sensitive(0);
									$s->{_page_5_proxy_host_e}->set_sensitive(0);
								      }
     								     });

  $vbox_page5->show_all;


  #GLOBAL SETTNGS
  $s->{_apply_page1} = Gtk2::Button->new_from_stock('gtk-apply'); 
  $s->{_apply_page1}->set_sensitive(0);
  $s->{_apply_page1}->signal_connect('clicked', sub { $s->_apply_changes });
  $s->{_close_page1} = Gtk2::Button->new_from_stock('gtk-close');
  $s->{_close_page1}->signal_connect('clicked', sub { $w->destroy });
  $s->{_button_box_page1} = new Gtk2::HButtonBox();
  $s->{_button_box_page1}->add( $s->{_apply_page1} );
  $s->{_button_box_page1}->add( $s->{_close_page1} );
  $s->{_button_box_page1}->set_layout_default('end');
  $vbox->pack_start($s->{_button_box_page1}, 0,0,0);
  $s->{_auto_save_e}->signal_connect_after('toggled',
    			sub{
				$s->_activate_apply;
				if ($s->{_auto_save_e}->active) {
					$s->{_auto_save_int_s}->set_sensitive(1) 
				} else {
					$s->{_auto_save_int_s}->set_sensitive(0)
				}
			}
    );
  $w->show_all();
}

#FIXME
#sub _notifier_selected {
#  my $s = shift;
#  my %a = @_;
#  
#  my $d = $s->{_notifier_pane_list}->get_row_data($a{row});
#  $s->log_debug("notifier was selected : ".$d->{_id});
#  my $n = RSSReader::GtkUI::Notifiers->get_notifier($d->{_id});
#
#  $s->{_notifier_pane}->remove( $s->{_feeds}->{$s->{_current_feed}}->{widget} ) if exists $s->{_current_feed};
#
#  $s->{_notifier_pane}->add2($s->{_feeds}->{$n->id()}->{widget}) if exists $s->{_feeds}->{$n->id()};
#
#  my $hbox  = new Gtk::VBox(9);
#  my $table = new Gtk::Table(3,2,0);
#  my $desc  = new Gtk::Label($n->description);
#  $desc->set_line_wrap(1);
#  $desc->set_alignment(0.5,0.0);
#  $table->attach($desc  ,0,2,0,1,['fill','shrink','expand'], [], 2,4);
#  $s->{_feeds}->{$n->id()}->{widget} = $hbox;
#
#  #the enable;
#  my $enable = new Gtk::CheckButton(' enable this notifier');
#  $enable->set_active(1) if $n->is_enabled;
#  $s->{_feeds}->{$n->id()}->{enable}->{widget} = $enable;
#  $s->{_feeds}->{$n->id()}->{enable}->{visual} = $n->is_enabled;
#  $table->attach($enable  ,1,2,1,2,['fill','shrink','expand'], [], 2,4);
#
#  #the options;
#  if (scalar(@{$n->config_options})) {
#   my $frame = new Gtk::Frame(" Options "); 
#   $frame->show();
#   $table->attach($frame  ,0,2,2,3, ['fill','shrink','expand'], ['expand','fill'], 2,4);
#
#   foreach my $option (@{$n->config_options}) {
#	#FIX ME
#   }
#   
#  }
# 
#  $table->show_all();
#  $hbox->pack_start($table, 1,1,1);
#  $hbox->show_all();
#
#  $s->{_feeds}->{$n->id()}->{enable}->{widget}->signal_connect_after('toggled',
#    			sub{
#				$s->_activate_apply;
#				if ($s->{_feeds}->{$n->id()}->{enable}->{widget}->active) {
#					$s->{_auto_save_int_s}->set_sensitive(1);
#					$s->_notifier_enable;
#				} else {
#					$s->{_auto_save_int_s}->set_sensitive(0);
#					$s->_notifier_disable;
#				}
#			}
#    );
#
#  $s->{_notifier_pane}->add2($hbox);
#}

sub _notifier_enable { }

sub _notifier_disable { }

sub _activate_apply {
  my $s = shift;
  $s->{_apply_page1}->set_sensitive(1);
  return 1;
}

sub _apply_changes {
  my $s = shift;

  my $conf  = RSSReader::Configuration->new();
  my $prefs = RSSReader::GtkUI::Preferences->new(); 

  if ( $s->{_auto_save_e}->get_active && ($s->{_auto_save_int_s}->get_value_as_int() == 0) ) {
	RSSReader::Gtk2UI::Dialog->run('You cannot save you data every 0 minutes');
	return;
  }
  if ($s->{_fetch_int_s}->get_value_as_int() == 0) {
	RSSReader::Gtk2UI::Dialog->run('You cannot fetch new data every 0 minutes');
	return;
  }

  if ($s->{_page_5_proxy_enable}->get_active && (!$s->{_page_5_proxy_host_e}->get_text)) {
	RSSReader::Gtk2UI::Dialog->run('Please insert a valid proxy host');
	return;
  }

  if ($s->{_page_5_proxy_enable}->get_active && (!$s->{_page_5_proxy_port_e}->get_text)) {
	RSSReader::Gtk2UI::Dialog->run('Please insert a valid proxy port');
	return;
  }
  
  $prefs->auto_save($s->{_auto_save_e}->get_active);
  $prefs->save_on_exit($s->{_save_on_exit_e}->get_active);
  $prefs->auto_save_interval($s->{_auto_save_int_s}->get_value_as_int());
  $prefs->fetch_interval($s->{_fetch_int_s}->get_value_as_int());
  $prefs->option('http_proxy_enabled', $s->{_page_5_proxy_enable}->get_active);
  $prefs->option('http_proxy_host'   , $s->{_page_5_proxy_host_e}->get_text);
  $prefs->option('http_proxy_port'   , $s->{_page_5_proxy_port_e}->get_text);



  #FIX ME
  #AND NOW CHANGED NOTIFIERS 
  #foreach my $id (keys %{$s->{_feeds}}) {
  #	my $n = RSSReader::GtkUI::Notifiers->get_notifier($id);
#	$s->log_debug("Notifier $id was modified");
#	if ($s->{_feeds}->{$id}->{enable}->{widget}->active) {
#		$n->enable;
#	} else {
#		$n->disable;
#	}
#  }
  #PAGE 4 - GUI Options
  $prefs->option('per_view_columns', (!$s->{_same_column_width_e}->get_active) );
  $prefs->option('per_view_pane',    (!$s->{_same_pane_size_e}->get_active)    );

  $s->{_apply_page1}->set_sensitive(0);
}

1;
